config/routes.rb
Rails.application.routes.draw do
  mount Ckeditor::Engine => '/ckeditor'
  devise_for :users, controllers: {registrations: "registrations"}
  post 'likes/create'
  post 'likes/destroy'
  post 'dislikes/create'
  post 'dislikes/destroy'
  post 'comments/reply'
  post 'comments/approve'
  get 'post/my', to: 'posts#my', as: :my_posts
  get 'posts/index', to: 'posts#index', as: :post_index

  resources :posts do
    resources :comments
    resources :ratings
  end

  resources :admin do
    resources :tags

    root to: "tags#index"
  end

  resources :tags
  resources :users

  root 'posts#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  acts_as_tree order: 'created_at DESC'
  belongs_to :user
  belongs_to :post #, dependent: :destroy
  has_many :like, dependent: :destroy
  has_many :dislike, dependent: :destroy

  validates :title, presence: {message: "Missing title"}
  validates :content, presence: {message: "Missing content"}

  before_save :generate_timestamp

  def generate_timestamp
    self.added = DateTime.now
  end

  def likes_count
    self.like.count()
  end

  def can_like id
    self.like.where(user_id: id).empty?
  end

  def dislikes_count
    self.dislike.count()
  end

  def can_dislike id
    self.dislike.where(user_id: id).empty?
  end

end

app/models/dislike.rb
class Dislike < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/post.rb
class Post < ApplicationRecord
  has_attached_file :image, styles: { large: "900x900>", medium: "500x500>", thumb: "100x100>" }
  validates_attachment_content_type :image, content_type: /\Aimage\/.*\z/


  has_many :comments, dependent: :destroy

  has_many :ratings, dependent: :destroy
  has_and_belongs_to_many :tags

  belongs_to :user

  has_one :post_option

  validates :title, presence: {message: "Missing title"}
  validates :perex, presence: {message: "Missing perex"}
  validates :text, presence: {message: "Missing text"}

  before_save :generate_timestamp
  before_create :build_associations

  def generate_timestamp
    self.added = DateTime.now
  end

  def assign_params_from_controller(params)
    @option_params = params
  end

  def build_associations
    #PostOption.new(@option_params).save
    self.post_option = PostOption.new(@option_params)
  end

  def primary_comments
    self.comments.where(parent_id: nil, approved: true).order(created_at: :desc)
  end

  def not_allowed_comments_for_current_user id
    self.comments.where(user_id: id, approved: false).order(created_at: :desc)
  end

  def not_allowed_comments
    self.comments.where(approved: false).order(created_at: :desc)
  end

end

app/models/post_option.rb
class PostOption < ApplicationRecord
end

app/models/rating.rb
class Rating < ApplicationRecord
  belongs_to :user
  belongs_to :post
  validates :value, numericality: { only_integer: true }, inclusion: { :in => [ 1, 2, 3, 4, 5 ] }
end

app/models/tag.rb
class Tag < ApplicationRecord
  has_and_belongs_to_many :posts
  validates :name, presence: {message: "Missing name of tag"}

end

app/models/under_comment.rb
class UnderComment < ApplicationRecord
  belongs_to :comment, dependent: :destroy
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable, :confirmable
  has_many :posts
end

app/controllers/likes_controller.rb
class LikesController < ApplicationController

  def new
    @like = Like.new(like_params)
  end

  def create

    @post = Post.find(params[:post_id])

    #destroy dislike if exists
    @dislikes = Dislike.where(user_id: params[:user_id],comment_id: params[:comment_id])
    unless @dislikes.empty?
      @dislikes.first.destroy
    end

    @like = Like.new(like_params)
    @comment = Comment.find(params[:comment_id])
    @like.save

    respond_to do |format|
      format.js
    end
  end

  def destroy

    @post = Post.find(params[:post_id])
    @like = Like.where(user_id: params[:user_id],comment_id: params[:comment_id]).take
    @like.destroy

    respond_to do |format|
      format.js
    end

  end

  private
  def like_params
    params.permit(:user_id, :comment_id)
  end

end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  # before_action :authenticate_user!

  def index

    if params[:tag]
      #filtered public posts
      @posts = public_posts.joins(:tags).where('name LIKE ?', "%#{params[:tag]}%")
    else
      #all public posts
      @posts = public_posts
    end
  end

  def show
    @post = Post.find(params[:id])
  end

  def new
    @post = Post.new
  end

  def edit
    @post = Post.find(params[:id])
  end

  def create
    @post = Post.new(post_params)
    @post.assign_params_from_controller(post_option_params)

    if @post.save
      redirect_to @post
    else
      #redirect back
      redirect_back fallback_location: root_path

      #show error message
      @post.errors.messages.each do |msg|
        flash[:warning] = msg.second
      end
    end
  end

  def update
    @post = Post.find(params[:id])

    if @post.update(post_params) and @post.post_option.update(post_option_params)
      redirect_to @post
    else
      render 'edit'
    end
  end

  def destroy
    @post = Post.find(params[:id])
    @post.destroy

    redirect_to posts_path
  end

  def my
    @current_user_posts = Post.joins(:user).where('users.id = ?', current_user.id)
  end

  private
  def post_params
    params.require(:post).permit(:title, :perex, :text, :added, :image, :user_id, :tag_ids => [])
  end

  def post_option_params
    params.require(:post_options).permit(:public, :comments_allowed, :comment_needs_approval)
  end

  def public_posts
    Post.joins(:post_option).where('post_options.public = true')
  end


end

app/controllers/tags_controller.rb
class TagsController < ApplicationController
  before_action :authenticate_user!

  def index
      @tags = Tag.all

  end

  ### show detail of tag
  def show
      @tag = Tag.find(params[:id])
  end

  ### new tag
  def new
    if current_user.admin?
      @tag = Tag.new
    else
       redirect_to root_path
    end
  end

  ### edit tag
  def edit
    if current_user.admin?
      @tag = Tag.find(params[:id])
    else
       redirect_to root_path
    end
  end

  ### create new tag
  def create
    if current_user.admin?
      @tag = Tag.new(tag_params)

      if @tag.save
        redirect_to @tag
      else
        #redirect back
        redirect_back fallback_location: root_path

        #show error message
        @tag.errors.messages.each do |msg|
          flash[:warning] = msg.second
        end
      end
    else
       redirect_to root_path
    end
  end

  ### update tag
  def update
    if current_user.admin?
      @tag = Tag.find(params[:id])

      if @tag.update(tag_params)
        redirect_to @tag
      else
        render 'edit'
      end
    else
       redirect_to root_path
    end
  end

  ### destroy chosen tag
  def destroy
    if current_user.admin?
      @tag = Tag.find(params[:id])
      @tag.destroy

      redirect_to tags_path
    else
       redirect_to root_path
    end
  end

  ### tag parameters
  private
  def tag_params
    params.require(:tag).permit(:name)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/dislikes_helper.rb
module DislikesHelper
end

app/helpers/likes_helper.rb
module LikesHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/ratings_helper.rb
module RatingsHelper
end

app/helpers/tag_posts_helper.rb
module TagPostsHelper
end

app/helpers/tags_helper.rb
module TagsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/likes/create.js.erb
$("#comments_div").html("<%= escape_javascript(render @post.primary_comments ) %>");

app/views/likes/destroy.js.erb
$("#comments_div").html("<%= escape_javascript(render @post.primary_comments ) %>");

app/views/posts/edit.html.erb
<div class="main-wrapper">
<div class="h1-block">
  <h1>Edit post</h1>
</div>
<%= form_for @post, html: { multipart: true } do |form| %>

  <% if @post.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@post.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @post.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= form.label :image %><br>
    <%= form.file_field :image, :class=> "form-control" %>
  </div>

  <div class="form-group">
    <%= form.label :title %><br>
    <%= form.text_field :title, :class=> "form-control" %>
  </div>

  <div class="form-group">
    <%= form.label :perex %><br>
    <%= form.text_field :perex, :class=> "form-control" %>
  </div>

  <div class="form-group">
    <%= form.label :text %><br>
    <%= form.cktext_area :text, :class=> "form-control ckeditor", ckeditor: { language: 'en'} %>
  </div>

  <div class="form-group">
    <% if defined?@post.user.name %>
      <strong>Author:</strong>
      <%= @post.user.name %>
    <% end %>  
  </div>

    <br>

    <%= form.label :tags %>
    <div class="form-group">
    <% Tag.all.each do |tag| %>
      <%= form.label tag.name %>
      <%= form.check_box :tag_ids,{multiple: true, checked: !@post.tags.where(id: tag.id).empty?}, tag.id, nil %>
      &nbsp;&nbsp;
    <% end %>
  </div>

  <br>

    <!-- TODO checkboxy -->
  <div class="form-group">
  <%= fields_for :post_options do |post_options_form| %>
      <%= post_options_form.label "Public post" %> <%= post_options_form.check_box :public, {checked: @post.post_option.public?} %>  <br />
      <%= post_options_form.label "Allow comments" %> <%= post_options_form.check_box :comments_allowed, {checked: @post.post_option.comments_allowed} %>  <br />
      <%= post_options_form.label "Show comments only after approval" %> <%= post_options_form.check_box :comment_needs_approval, {checked: @post.post_option.comment_needs_approval} %>  <br />
  <% end %>
  </div>



  <div>
    <%= form.submit 'Edit post', :class => 'btn btn-lg btn-black'  %>
  </div>

<% end %>


<%= link_to posts_path, class: "btn btn-back" do %>
  <span class="glyphicon glyphicon-arrow-left"></span> Back
<% end %>

</div>

app/views/posts/index.html.erb
<!--  SEARCH BY TAGS  -->
<div class="row">
  <div class="col-lg-12">
    <%= form_tag post_index_path, method: :get do %>
      <div class="input-group">
        <%= text_field_tag :tag, params[:tag], placeholder: 'Search by tags...', :class=> "form-control"%>
        <span class="input-group-btn">
          <%= submit_tag 'Search', name: nil, method: :get, :class=> "btn btn-default" %>
        </span>
      </div>
    <% end %>
  </div><!-- /.col-lg-6 -->
</div><!-- /.row -->

<!-- POSTS CARDS -->
<div class="row">
  <% @posts.each do |post| %>
  <div class="col-sm-6 col-md-4">
    <div class="thumbnail">
      <% unless post.image_file_name.nil? %>
        <%= link_to post_path(post) do %>
          <%= image_tag post.image.url(:medium) %>
        <% end %>  
      <% end %>  
      <div class="caption">
        <h3><%= link_to post.title, post_path(post), :class=> "black" %></h3>
        <p><br/>
          <% unless post.ratings.average(:value).nil? %>
            <i><strong>Rating: </strong><%= post.ratings.average(:value) %></i>
          <% end %>
        </p>

        <% if current_user.admin? %>
        <p><br/>
          <%= link_to 'Edit', edit_post_path(post), :class=> "btn btn-green" %>
          <%= link_to 'Delete', post_path(post),
                      method: :delete,
                      data: { confirm: 'Are you sure?' }, :class=> "btn btn-danger" %>
        </p>
        <%end%>

      </div>
    </div>
  </div>
  <% end %>
</div><!--/row-->

app/views/posts/my.html.erb
<div class="h1-block">
  <h1>MY POSTS</h1>
</div>

<div class="row">
  <div class="col-lg-12">
      <%= form_tag post_index_path, method: :get do %>
        <div class="input-group">
        <%= text_field_tag :tag, params[:tag], placeholder: 'Search by tags...', :class=> "form-control"%>
        <span class="input-group-btn">
          <%= submit_tag 'Search', name: nil, method: :get, :class=> "btn btn-default" %>
        </span>
        </div>
      <% end %>
  </div><!-- /.col-lg-6 -->
</div><!-- /.row -->


<!-- POSTS CARDS -->
<div class="row">
  <% @current_user_posts.each do |post| %>
  <div class="col-sm-6 col-md-4">
    <div class="thumbnail">
      <% unless post.image_file_name.nil? %>
        <%= link_to post_path(post) do %>
          <%= image_tag post.image.url(:medium) %>
        <% end %>
      <% end %>  
      <div class="caption">
        <h3><%= link_to post.title, post_path(post), :class=> "black" %></h3>
        <!-- <p>...</p> -->
        <p><br/>
          <%= link_to 'Edit', edit_post_path(post), :class=> "btn btn-green" %>
          <%= link_to 'Delete', post_path(post),
                      method: :delete,
                      data: { confirm: 'Are you sure?' }, :class=> "btn btn-danger" %>
        </p>
      </div>
    </div>
  </div>
  <% end %>
</div><!--/row-->

app/views/posts/new.html.erb
<div class="main-wrapper">
<div class="h1-block">
  <h1>Add new post</h1>
</div>  
<%= form_with scope: :post, url: posts_path, local: true, html: { multipart: true } do |form| %>
  <%= form.hidden_field :user_id, :value => current_user.id %>

  <% if @post.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@post.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @post.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= form.label :image %><br>
    <%= form.file_field :image, :class=> "form-control" %>
  </div>

  <div class="form-group">
    <%= form.label :title %><br>
    <%= form.text_field :title, :class=> "form-control" %>
  </div>

  <div class="form-group">
    <%= form.label :perex %><br>
    <%= form.text_area :perex, :class=> "form-control" %>
  </div>

  <div class="form-group">
    <%= form.label :text %><br>
    <%= form.cktext_area :text, :class=> "form-control ckeditor", ckeditor: { language: 'en'} %>
  </div>

    <%= form.label :tags %>
    <div class="form-check form-check-inline">
    <% Tag.all.each do |tag| %>
      <%= form.label tag.name, {class: "form-check-label"} %>
      <%= form.check_box :tag_ids,{multiple: true, checked: false, class: 'form-check-input'}, tag.id, nil %>
        &nbsp;&nbsp;
    <% end %>
  </div>

    <br>

    <div class="form-group">
    <%= form.label :author %><br>
    <%= current_user.name %>
  </div>


  <div class="form-group">
  <%= fields_for :post_options do |post_options_form| %>
      <%= post_options_form.label "Public post" %> 
      <%= post_options_form.check_box :public, {checked: true} %> 

    <!-- </div> -->
    <!-- <div class="checkbox">  -->
      <%= post_options_form.label "Allow comments" %> 
      <%= post_options_form.check_box :comments_allowed, {checked: true} %>  <br />

      <%= post_options_form.label "Show comments only after approval" %>
      <%= post_options_form.check_box :comment_needs_approval, {checked: false} %>
  <% end %>
  </div>  

  <%= form.submit 'Create post', :class => 'btn btn-lg btn-black' %>

<% end %>


<%= link_to posts_path, class: "btn btn-back" do %>
  <span class="glyphicon glyphicon-arrow-left"></span> Back
<% end %>
<p></p>

</div>

app/views/posts/show.html.erb
<div class="main-wrapper">



<!-- TITLE  -->
<div class="h1-block">
  <h1><%= @post.title %></h1>
</div>


<!-- IMAGE -->
<% unless @post.image_file_name.nil? %>
  <div><%= image_tag @post.image.url(:large), :class=> "img-responsive" %></div><br>
<% end %>

<!-- DATE  -->
<p class="grey"><strong class="grey">Added:</strong>
  <%= @post.added %></p>
<!-- PEREX -->
<div class="post-perex">
  <p><%= @post.perex %></p>
</div>
<!-- TEXT -->
<p>
  <%= raw @post.text %>
</p><br/>
<!-- AUTHOR -->
<p class="grey right">
  <% unless @post.user.name.nil? %>
    <strong class="grey">Author:</strong>
    <%= @post.user.name %>
  <% end %>
</p>  
<!-- TAGS -->

<h4><% unless @post.tags.empty? %>
    <strong>Tags:</strong>
    <% @post.tags.each do |tag| %>
      <div class="tag">
        <%= link_to tag.name, tag_path(tag), class: "nounderline" %>

      </div>
    <% end %>
<% end %>
</h4><br/>

<!-- RATING -->
<h4>
  <% unless @post.ratings.empty? %>
    <strong>Rating:</strong>
    <%= @post.ratings.average(:value) %>
  <% end %> 
</h4><br/>

<p><h4>Rate this post:</h4>
<%= render 'ratings/form' %>
</p>

<% if @post.post_option.comments_allowed %>

  <% if @post.user_id == current_user.id%>
    <% unless @post.not_allowed_comments.empty? %>
      <h4>These comments need approval:</h4>
      <%= render partial: 'comments/unpermitted_comment', collection: @post.not_allowed_comments, as: :comment %>
    <% end %>
  <% end %>

    <% if !@post.not_allowed_comments_for_current_user(current_user.id).empty? and @post.user_id != current_user.id%>
      <h4>These comments are waiting for approval:</h4>
      <%= render partial: 'comments/unpermitted_comment', collection: @post.not_allowed_comments_for_current_user(current_user.id), as: :comment %>
    <% end %>


    <h4>Add a comment:</h4>
  <%= render 'comments/form' %>
  <p class="line-break"></p>

  <h4>Comments: <%= @post.primary_comments.count() %></h4></p>
    <div id="comments_div">
      <%= render @post.primary_comments %>
    </div>

<% end %>

<% if @post.user_id == current_user.id %>
	<%= link_to 'Edit post', edit_post_path(@post), :class=> "btn btn-green" %>
    <%= link_to post_path, method: :delete, data: { confirm: 'Are you sure?' }, class: "btn btn-danger" do %>
      Delete
    <% end %>
<% end %>


<div>
  <%= link_to posts_path, class: "btn btn-back" do %>
    <span class="glyphicon glyphicon-arrow-left"></span> All Posts
  <% end %>
</div>

</div>